package provide chatlogic 0.1

package require chatmodel

namespace eval chat::logic {}

proc chat::logic::login {nick pass} {
    if { [chat::model::exists $nick] } {
	if { [chat::model::checkpass $nick $pass] == 1 } {
	    chat::gui::main $nick
	} else {
	    chat::gui::error "User/Password Incorrect"
	    chat::gui::login
	}
    } else {
	chat::gui::error "You need to create a new user"
	chat::gui::login
    }
}

proc chat::logic::chat {nick {msg {}}} {
    # client side protocol
    switch -exact [lindex $msg 0] {
	/msg {
	    chat::model::privmsg $nick [lindex $msg 1] [join [lrange $msg 2 end]]
	}
	/kick {
	    chat::model::kick $nick [lindex $msg 1] [join [lrange $msg 2 end]]
	}
	/quit {
	    chat::model::quit $nick
	    chat::gui::quit
	    return
	}
	default {
	    chat::model::msg $nick $msg
	}
    }
    chat::gui::updatemain $nick
}

proc chat::logic::newuser {nick pass pwconfirm} {
    if { $pass != $pwconfirm } {
	chat::gui::error "Password and Password Confirmation don't match - please go back and try again"
    } else {
	chat::model::adduser $nick $pass
	chat::gui::main $nick
    }
}