package provide chatmodel 0.1

# For now, this just does stuff directly, instead of passing it off to
# a specific backend.

namespace eval chat::model {
    set passfile pass.txt
    set PORT 9988
}

proc chat::model::getpasslist {} {
    variable passfile
    set fl [open pass.txt]
    gets $fl passlist
    close $fl
    return $passlist
}

proc chat::model::exists {nick} {
    array set pass [chat::model::getpasslist]
    return [info exists pass($nick)]
}

proc chat::model::checkpass {nick pass} {
    array set Pass [chat::model::getpasslist]
    if { ! [info exists Pass($nick)] } {
	error "checking password for nonexistant nick"
    }
    if { $pass == $Pass($nick) } {
	return 1
    } else {
	return 0
    }
}

proc chat::model::getsock {} {
    variable PORT
    variable sk
    if { ! [info exists sk] } {
	set sk [socket localhost $PORT]
	fconfigure $sk -buffering line
    }
    return $sk
}

proc chat::model::getlines {nick} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd get msg ""]
    if { ! [eof $sk] } {
	gets $sk data
	return "$data"
    } else {
	error "Problem with socket"
    }
}

proc chat::model::who {nick} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd who msg ""]
    gets $sk data
    return $data
}

proc chat::model::privmsg {nick target txt} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd privmsg target $target msg $txt]
}

proc chat::model::kick {nick target txt} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd kick target $target msg $txt
}

proc chat::model::quit {nick} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd quit msg ""]
}

proc chat::model::msg {nick txt} {
    set sk [chat::model::getsock]
    puts $sk [list nick $nick cmd msg msg $txt]
}

proc chat::model::adduser {nick pass} {
    set passlist [chat::model::getpasslist]
    array set pw $passlist
    set pw($nick) $pass
    set fl [open pass.txt w]
    puts $fl [array get pw]
    close $fl
}